#!/bin/sh
# %%% Package Version 1998.2.0       1998.10.9
# script for testing package for all/each categories with plain/latex 1998.9
#                                aoki@hep.s.kanazawa-u.ac.jp 
#                                uehara@yukawa.kyoto-u.ac.jp 
# check debug.doc first

# set mode of check
TEX=1
LATEX=1
PRE=0
PRINT=0

# set local commands to call
texcmd=jtex
latexcmd=jlatex
precmd=xdvi

# set print command. 
# "pr_script" should send a dvi_file directly to a printer
pr_script=dvi2lp

## if you want to pipe dvifiler to printcomand 
## 1) uncomment  USEPIPE_FOR_PR=1
## 2) set dvifilter and lpcmd properly

#USEPIPE_FOR_PR=1
dvitops=dvi2ps
lpcmd=lp

#####  end of site dependent part ######
########################################
program=`basename $0`
usage (){
exec 1>&2
echo "usage:  $program [options]"
echo '
    option: 
           -h      : this help
           -l [LTX]: latex only, no tex (run LTX for LaTeXing)
           -t [TeX]: tex only, no latex (run TeX for TeXing)
           -p      : print
           -v      : preview
	   -a      : complie whole sets (default)
           -1      : compile  
           -2      : compile Ղ`a
           -3      : compile Ղb
           -4      : compile Ղ`aWJ
           -5      : compile Ղb
           -6      : compile G
           -7      : compile `
'
exit 1
}

###
numreset() {
    if [ $ALLFIELD = 1 ]; then
	ALLFIELD=0
	TOKUT=0;AB_IP=0;C_IPP=0;AB_TE=0;C_KIK=0;HOUGA=0;SHOUR=0
    fi
}
###
prtdvi () {
    if [ x$USEPIPE_FOR_PR = x1 ]; then
	$dvifilter $1 | $lpcmd
    else
	$pr_script $1
    fi
}

ALLFIELD=1
SRC=0;TCMD=0;LTCMD=0
texsrc=src

for arg in `echo ---DummY "$@"`
do
    case $arg in
    -t|-T)  TEX=1;LATEX=0;SRC=0;TCMD=1;LTCMD=0 ;;
    -l|-L)  TEX=0;LATEX=1;SRC=0;TCMD=0;LTCMD=1 ;;
    -s|-S)  SRC=1;TCMD=0;LTCMD=0 ;;
    -s*|-S*)
	    texsrc=`echo "x$arg"|sed 's/^x-s//;s/\.tex$//'` ;;
    ---DummY) ;;
    -|--*) usage;;
    -*)
	for i in `echo "x$arg"|sed -e 's/^x-//' -e 's/\(.\)/\1 /g'`
	do
	case $i in
	1) numreset && [ x$TOKUT = x0 ] && TOKUT=1 && SUB="$SUB TOKUT" ;;
	2) numreset && [ x$AB_IP = x0 ] && AB_IP=1 && SUB="$SUB AB_IP" ;;
	3) numreset && [ x$C_IPP = x0 ] && C_IPP=1 && SUB="$SUB C_IPP" ;;
	4) numreset && [ x$AB_TE = x0 ] && AB_TE=1 && SUB="$SUB AB_TE" ;;
	5) numreset && [ x$C_KIK = x0 ] && C_KIK=1 && SUB="$SUB C_KIK" ;;
	6) numreset && [ x$HOUGA = x0 ] && HOUGA=1 && SUB="$SUB HOUGA" ;;
	7) numreset && [ x$SHOUR = x0 ] && SHOUR=1 && SUB="$SUB SHOUR" ;;
	a|A) ;;
	l|L) TEX=0;LATEX=1;;
	p|P) PRINT=1 ;;
	t|T) TEX=1;LATEX=0;;
	v|V) PRE=1 ;;
	*) usage;;
	esac
	done
	;;
    *)
	if [ x$SRC = x1 ]; then
	    texsrc=`echo $arg|sed 's/\.tex$//'`
	elif [ x$TCMD = x1 ]; then
	    texcmd=$arg
	elif [ x$LTCMD = x1 ]; then
	    latexcmd=$arg
	else
	    usage
	fi
	SRC=0;TCMD=0;LTCMD=0;;
    esac
done

##########################################
if [ $ALLFIELD = 1 ]; then
    SUB="TOKUT AB_IP C_IPP AB_TE C_KIK HOUGA SHOUR"
fi
texok=0
trap "/bin/rm -f benchcompile.fileset; exit 1" 1 2 3 9 15
for i in $SUB
do
    sed -e '1,/^%%debug_tool/d;/^%%end_of_debug_tool/,$d' \
    -e "s@\def\\\\\(.*\){}  *%%%$i@\1@;s@^%%@@" kkhgrp.mac > benchcompile.fileset
    [ x$TEX = x1 ] && $texcmd $texsrc && texok=1
    [ x$LATEX = x1 ] && $latexcmd $texsrc && texok=1
    [ x$PRE = x1 -a $texok = 1 ] && $precmd $texsrc.dvi
    [ x$PRINT = x1 -a $texok = 1 ] && prtdvi $texsrc.dvi
done
[ -f benchcompile.fileset ] && /bin/rm benchcompile.fileset
